//*************************************************************
//	   Java application
//			uJarOperationv
//
//@@@@@@@@@@@@ҁF[g؁@@@
//@@@@@@@@@@쐬JnFQOOW^Q
//@@@@@@@@@@ŏIXVFQOOW^Q    [TN119/J109]
//*************************************************************
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.jar.Attributes;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;
import java.util.jar.JarOutputStream;
import java.util.jar.Manifest;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;


public class JarOperation extends JPanel implements ActionListener {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;

	public static void main(String[] args) {
		JFrame frame=new JFrame();
		frame.getContentPane().add(new JarOperation());
		frame.setTitle("JarOperation");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);	//E~ŏI
		frame.setSize(700,400);
		frame.setVisible(true);
		frame.setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//------------------------------------------------------------------
	//
	File file;		//𓀌EkJARt@C
	File folder;	//𓀐Ek̃tH_
	//
	JTextField textJar=new JTextField(30);
	JButton buttonJar=new JButton("JARI");
	JButton buttonJarToFolder=new JButton("ẽtH_ɉ");
	JTextField textFolder=new JTextField(30);
	JButton buttonFolder=new JButton("tH_I");
	JButton buttonFolderToJar=new JButton("eJARɈk");
	JTextArea textOutput=new JTextArea();
	//------------------------------------------------------------------
	//
	public JarOperation(){
		//
		file=folder=null;
		//
		JPanel panelJar=new JPanel();
		panelJar.add(textJar);
		panelJar.add(buttonJar);
		panelJar.add(buttonJarToFolder);
		//
		JPanel panelFolder=new JPanel();
		panelFolder.add(textFolder);
		panelFolder.add(buttonFolder);
		panelFolder.add(buttonFolderToJar);
		//
		setLayout(new BorderLayout());
		add(panelJar,BorderLayout.NORTH);
		add(new JScrollPane(textOutput),BorderLayout.CENTER);
		add(panelFolder,BorderLayout.SOUTH);
		//
		buttonJar.addActionListener(this);
		buttonJarToFolder.addActionListener(this);
		buttonFolder.addActionListener(this);
		buttonFolderToJar.addActionListener(this);
	}
	//------------------------------------------------------------------
	//
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==buttonJar){					//JARIiɏ\j
			//JARt@CI_CAO
			JFileChooser chooser=new JFileChooser(file);
			FileFilter filter=new FileNameExtensionFilter("JARt@C","jar");
			chooser.addChoosableFileFilter(filter);
			chooser.setAcceptAllFileFilterUsed(false);	//{́uׂĂ\vtB^[\Ȃ
			//
			if(chooser.showOpenDialog(this)==JFileChooser.APPROVE_OPTION){
				file=chooser.getSelectedFile();
				textJar.setText(file.toString());
				//
				if(file.exists()){
					try {
						JarFile jarFile = new JarFile(file);
						textOutput.setText(outputJarInfo(jarFile));
					} catch (IOException ioe) {
						textOutput.setText(ioe.toString());
					}
				}else{
					textOutput.setText("file not found");
				}
			}
		}else if(object==buttonFolder){			//tH_I
			//tH_I_CAO
			JFileChooser chooser=new JFileChooser(folder);
			chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			//
			if(chooser.showSaveDialog(this)==JFileChooser.APPROVE_OPTION){
				folder=chooser.getSelectedFile();
				textFolder.setText(folder.toString());
				//
			}
		}else if(object==buttonJarToFolder){	//
			if(file==null){
				JOptionPane.showMessageDialog(this,"JARt@Cw肵Ă","G[",JOptionPane.ERROR_MESSAGE);
				return;
			}else if(!file.exists()){
				JOptionPane.showMessageDialog(this,"JARt@C݂܂","G[",JOptionPane.ERROR_MESSAGE);
				return;
			}
			//
			if(folder==null){
				JOptionPane.showMessageDialog(this,"𓀐tH_w肵Ă","G[",JOptionPane.ERROR_MESSAGE);
				return;
			}
			folder.mkdirs();	//o͐tH_݂ȂȂ̂ō쐬
			//
			try {
				JarFile jarFile=new JarFile(file);
				//
				Enumeration enm=jarFile.entries();
				while(enm.hasMoreElements()){
					JarEntry jarEntry=(JarEntry)enm.nextElement();
					entryToFile(jarFile,jarEntry);
				}
				//
				JOptionPane.showMessageDialog(this,"𓀂܂","",JOptionPane.INFORMATION_MESSAGE);
			} catch (IOException ioe) {
				JOptionPane.showMessageDialog(this,ioe.toString(),"G[",JOptionPane.ERROR_MESSAGE);
			}
		}else if(object==buttonFolderToJar){	//k
			if(file==null){
				JOptionPane.showMessageDialog(this,"JARt@Cw肵Ă","G[",JOptionPane.ERROR_MESSAGE);
				return;
			}
			//
			if(folder==null){
				JOptionPane.showMessageDialog(this,"ktH_w肵Ă","G[",JOptionPane.ERROR_MESSAGE);
				return;
			}else if(!folder.exists()){
				JOptionPane.showMessageDialog(this,"ktH_݂܂","G[",JOptionPane.ERROR_MESSAGE);
				return;
			}
			//
			try {
				//}jtFXg쐬
				Manifest manifest=new Manifest();
				Attributes attributes=manifest.getMainAttributes();
				attributes.put(Attributes.Name.MANIFEST_VERSION, "1.0");
				//̃}jtFXgJAR
				JarOutputStream jos=new JarOutputStream(new BufferedOutputStream(new FileOutputStream(file)),manifest);
				//
				filesToJar(folder,jos);
				//
				jos.close();
				//
				JOptionPane.showMessageDialog(this,"k܂","",JOptionPane.INFORMATION_MESSAGE);
			} catch (IOException ioe) {
				JOptionPane.showMessageDialog(this,ioe.toString(),"G[",JOptionPane.ERROR_MESSAGE);
			}
		}
	}
	//------------------------------------------------------------------k
	//w肳ꂽtH_ȉɂSt@CJARɏށiċAĂяoj
	private void filesToJar(File outFolder,JarOutputStream jos) throws IOException{
		String[] outFilesList=outFolder.list();
		//
		File outFile;
		for(int f=0;f<outFilesList.length;f++){
			outFile=new File(outFolder.getPath()+File.separator+outFilesList[f]);	//΃pX
			//
			if(outFile.isFile()){				//t@CȂ珑
				fileToEntry(outFile,jos);
			}else if(outFile.isDirectory()){	//tH_ȂċAĂяo
				filesToJar(outFile,jos);
			}
		}
	}
	//w肳ꂽt@CJARɏ
	private void fileToEntry(File outFile,JarOutputStream jos) throws IOException{
		BufferedInputStream bis=new BufferedInputStream(new FileInputStream(outFile));
		//Gg[ǉi΃pX𑊑΃pXɏCj
		JarEntry outEntry=new JarEntry(outFile.getPath().substring(folder.getPath().length()+1));	//+1̓Zp[^[̕
		jos.putNextEntry(outEntry);
		//
		int b;
		while((b=bis.read())!=-1){
			jos.write((byte)b);
		}
		//
		jos.closeEntry();
		bis.close();
	}
	//------------------------------------------------------------------
	//
	private void entryToFile(JarFile jarFile,JarEntry jarEntry) throws IOException{
		File outFile=new File(folder+File.separator+jarEntry.getName());	//΃pX
		//
		if(outFile.isDirectory()){	//fBNgȂtH_쐬̂
			outFile.mkdirs();
		}else{						//t@CȂtH_쐬iKvȂjăt@Co
			//t@Ci[tH_܂݂ȂȂ̂ō쐬
			File parentFolder=new File(outFile.getParent());
			parentFolder.mkdirs();
			//
			BufferedInputStream bis=new BufferedInputStream(jarFile.getInputStream(jarEntry));
			BufferedOutputStream bos=new BufferedOutputStream(new FileOutputStream(outFile));
			//
			int b;
			while((b=bis.read())!=-1){
				bos.write((byte)b);
			}
			//
			bis.close();
			bos.close();
		}
	}
	//------------------------------------------------------------------JAR擾
	private String outputJarInfo(JarFile jarFile){
		StringBuffer buf=new StringBuffer();
		//
		buf.append(outputMainAttributes(jarFile)+"\n");
		buf.append(outputFileAttributes(jarFile)+"\n");
		buf.append(outputFileEntries(jarFile)+"\n");
		//
		return buf.toString();
	}
	//JARŗL̃Agr[g
	private String outputMainAttributes(JarFile jarFile){
		StringBuffer buf=new StringBuffer();
		//
		try {
			Manifest mf=jarFile.getManifest();
			Attributes att=mf.getMainAttributes();
			//
			buf.append("*** Manifest Main Attributes ***"+"\n");
			//
			Iterator itr=att.keySet().iterator();
			while(itr.hasNext()){
				Attributes.Name name=(Attributes.Name) itr.next();
				buf.append(name.toString()+":"+att.getValue(name)+"\n");
			}
		} catch (IOException e) {
			return e.toString();
		}
		//
		return buf.toString();
	}
	//i[t@C̃Agr[g
	private String outputFileAttributes(JarFile jarFile){
		StringBuffer buf=new StringBuffer();
		//
		try {
			Manifest mf=jarFile.getManifest();
			Attributes att;
			//
			Enumeration enm=jarFile.entries();
			buf.append("*** Manifest File Attributes ***"+"\n");
			//
			while(enm.hasMoreElements()){
				String str=((JarEntry)enm.nextElement()).toString();
				att=mf.getAttributes(str);
				if(att==null){	continue;	}
				//
				Iterator itr=att.keySet().iterator();
				Attributes.Name name=(Attributes.Name) itr.next();
				buf.append(name.toString()+":"+att.getValue(name)+"\n");
			}
		} catch (IOException e) {
			return e.toString();
		}
		//
		return buf.toString();
	}
	//i[t@ČX̏
	private String outputFileEntries(JarFile jarFile){
		StringBuffer buf=new StringBuffer();
		//
		Enumeration enm=jarFile.entries();
		buf.append("*** File Entries ***"+"\n");
		//
		while(enm.hasMoreElements()){
			buf.append(((JarEntry)enm.nextElement()).getName()+"\n");
		}
		//
		return buf.toString();
	}
}
